#ifndef P4CONNECTION_H
#define P4CONNECTION_H

#include "p4api.h"

#include <QObject>
#include <QString>
#include <QStringList>
#include <QVariant>

class P4Connection : public QObject
{
    Q_OBJECT
public:
    explicit P4Connection(QVariantMap config, QString conName, P4Api* p);

    Q_INVOKABLE QString     getName() {return m_name;}

//    Q_INVOKABLE void        setPort(const QString& port) {m_port = port;}
//    Q_INVOKABLE void        setUser(const QString& user) {m_user = user;}
//    Q_INVOKABLE void        setClient(const QString& client) {m_client = client;}
//    Q_INVOKABLE void		  setCharset(const QString& charset) {m_charset = charset;}

    Q_INVOKABLE QString getPort() {return m_port;}
    Q_INVOKABLE QString getUser() {return m_user;}
    Q_INVOKABLE QString getClient() {return m_client;}
    Q_INVOKABLE QString	getCharset() {return m_charset;}

    Q_INVOKABLE QVariant _run(QVariantList cmd);

    Q_INVOKABLE QObject* _createBGRunner(QVariantList cmd);
    void destroyBGRunner(QObject* runner);

    Q_INVOKABLE void destroy();

signals:

public slots:

private:
    QString m_name;

    QString m_port;
    QString m_user;
    QString m_client;
    QString m_charset;

    P4Api* m_P4Api;
};

#endif // P4CONNECTION_H
